# Enjoy_Container

Dieses Repository dient der Verwaltung der Dockerfiles für die Jupytermachine an der Fakultät für Physik.

## Erstellen eines neuen Containers
Um einen neuen Container zu erstellen sind folgende Schritte notwendig:
 1. Erstellen eines neune Ordners in diesem Repository. Der Name des Ordners wird dem Namen des Containers entsprechen.
 2. Erstellen eines Dockerfiles in diesem Ordner.
    Ein Dockerfile beginnt mit den Zeilen:

    ```docker
    FROM gitlab.etp.kit.edu:5050/enjoy/course-container/basis:latest
    USER root
    ```

    Danach können die benötigten Pakete installiert werden mit

    ```docker
    RUN <bash Befehl>
    ```

    Als Beispiel kann der Container "python" dienen.
    Die letzte Zeile im Dockerfile muss 
    
    ```docker
    USER $NB_USER
    ```

    sein.
 4. Lokal den Container testen:
    Einmal, ob der Container gebaut wird:

    ```bash
    docker build -t <Containername> .
    ```
    
    Dann ob er wie gewünscht funktioniert:

    ```bash 
    docker run -p 8888:8888 -v <workdir>:/home/jovyan --user "$(id -u):$(id -g)" --env JUPYTER_ENABLE_LAB=true  <Containername>
    ```

 5. Speichern des Containers mit 
    
    ```bash
    git commit -m <Containername>
    git push
    ```

 6. Informieren des Jupyter-Hiwis, um den Container freischalten zu lassen.

## Testumgebung
In Arbeit

## Images lokal verwenden
Die Images können auch auf einen lokalen Rechner gepullt werden und ausgeführt werden mit 

```bash
docker run -p 8888:8888 -v <workdir>:/home/jovyan --user "$(id -u):$(id -g)" --env JUPYTER_ENABLE_LAB=true  gitlab.etp.kit.edu:5050/jeppelt/enjoy_container/<image>
```

.
